new;
library gro,pde,pgraph;
PDEset;

graphset;
  begwind;
  window(2,2,0);

    fonts("simplex simgrma complex microb");

    _plwidth = 5; _pltype = 6;

    _pdate = ""; _pnum = 2; _pframe = 0; 
    _ptitlht = 0.25; _pnumht = 0.20; _paxht = 0.20;
    xtics(-2,22,2,0);
    ytics(-8,8,1,0);
    xlabel("\203t\201");
    ylabel("\203 \201");
    _pypmax = 0;
    let xlab = "" "0.0" "" "0.2" "" "0.4" "" "0.6" "" "0.8" "" "1.0" "";
    let ylab = "" "" "-3" "" "-2" "" "-1" "" "0" "" "1" "" "2" "" "3" "" ;
    asclabel(xlab,ylab);
    _pde_symsiz = 2;
    _pde_symclr = 12;

  setwind(1);
    title("Temporal non-uniform grid");
    t = seqa(0.01,0.97/20,21);
    t = 2*cdfchii(t,3*ones(rows(t),1));
    x = seqa(0.02,0.96/20,21);
    x = cdfchii(x .* ones(1,rows(t)),3 + sqrt(1.05+sin(2*t')) .*ones(rows(x),rows(t)));
    x = x .* besselj(t',1);
    x = x ./ maxc(abs(x))' * 14 - 7;
    x[1,.] = -7 * ones(1,rows(t));
    x[rows(x),.] = 7 * ones(1,rows(t));
    {_psym,_pline} = plotGrid(t,x,9,1,0);
    draw;

  setwind(2);
    title("Non-constant boundaries");
    t = seqa(0.01,0.97/30,31);
    t = 2*cdfchii(t,3*ones(rows(t),1));

    proc (2) = xGrid2(i);
      local x;
      x = seqa(0.01,0.98/30,31);
      x = sqrt(10-abs(t[i]-10))*cdfni(x);
      retp(t[i],x);
    endp;

    Nt = rows(t);
    dataset = "tmp";
    call saveGrid(Nt,&xGrid2,dataset);
    {t,x} = loadGrid(dataset);
    {_psym,_pline} = plotGrid(t,x,9,1,0);
    xy(t,minc(x)~maxc(x));

    _psym = {}; _pline = 0;

  setwind(3);
    title("Non-constant number of discretization in x");
    t = seqa(0.01,20/20,21);
    x = {};

    i = 1;
    do until i > rows(t);
      Ni = trunc(5 + 30*rndu(1,1));
      xi = seqa(0.01,0.97/(Ni-1),Ni);
      xi = cdftci(xi,10.*ones(Ni,1));
      xi = (xi-minc(xi)) ./ (maxc(xi)-minc(xi)) * 14 - 7;
      _psym = _psym | 
               t[i]*ones(Ni,1)~xi~(9~_PDE_symsiz~_PDE_symclr~1~0).*ones(Ni,1);

      
      i = i + 1;
    endo;
    draw;

    _psym = 0;

  setwind(4);
    title("Non-constant boundaries");
    t_ = seqa(0,20/20,21);
    N = 30;
    t = seqa(0,20/(N-1),N);

    let xmin = -7 -6 -5 -4 -5 -6 -7 -7 -7 -7 -6 -5 -4 -3 -2 -1 0 1 1 -3 -7 ;
    let xmax = 7 6 5 4 5 6 7 6 5 7 6 5 4 3 2 2 2 3 4 5 7 ;
    xmin = fspline(csspline(t_,xmin,1,0.9),t);
    xmax = fspline(csspline(t_,xmax,1,0.9),t);

    N = 20;
    x = seqa(0.01,0.97/(N-1),N);
    x = cdftci(x,10);
    x = (x-minc(x)) ./ (maxc(x)-minc(x)) .* (xmax-xmin)' + xmin';
    {_psym,_pline} = plotGrid(t,x,9,1,0);
    xy(t,xmin~xmax);

    graphprt("-c=1 -cf=grid2.ps");

  endwind;

  