/*
** tutor.inc
*/

tmin = 0;
tmax = 1;
M = 11;

xmin = -1;
xmax = 1;
N = 21;

proc uProc(t,x);
  retp( (x^2+x)*exp(-t) + x );
endp;

proc duProc(t,x);
  retp( (2*x+1)*exp(-t) + 1 );
endp;

proc aProc(t,x);
  retp( 0.5* (x^2) );
endp;

proc bProc(t,x);
  retp( x );
endp;

proc cProc(t,x);
  retp( ones(rows(x),1) );
endp;

proc dProc(t,x);
  retp( -(3*x^2+x)*exp(-t) );
endp;

proc tminBound(t,x);
  retp( uProc(t,x) );
endp;

proc xminBound(t,x);
  retp( uProc(t,x) );
endp;

proc xmaxBound(t,x);
  retp( uProc(t,x) );
endp;

proc DxminBound(t,x);
  retp( duProc(t,x) );
endp;

proc DxmaxBound(t,x);
  retp( duProc(t,x) );
endp;

proc invcdf(u);
  local x;

  u = substute(u,u .== 0,1e-3);
  u = substute(u,u .== 1,1-1e-3);

  x = cdfni(u);
  x = ( x - minc(x) ) / ( maxc(x) - minc(x) );
  x = xmin + xmax * (x - xmin) * (xmax - xmin) ;
 
  retp(x);
endp;



